<template>
	<div class="StratifyButton">
		<v-btn rounded outlined color="primary" @click="handleClick"
			>Stratify {{ (initialFieldIds && initialFieldIds.length && `(${initialFieldIds.length})`) || '' }}</v-btn
		>
		<v-dialog persistent v-model="isDialogVisible" max-width="50em">
			<v-card>
				<v-card-title>Stratify</v-card-title>
				<v-card-text class="flex-grow-1">
					<stratify-form
						v-if="isDialogVisible"
						:initialFieldIds="initialFieldIds"
						@submissionSuccess="isDialogVisible = false"
						@cancel="isDialogVisible = false"
					/>
				</v-card-text>
			</v-card>
		</v-dialog>
	</div>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api';
import StratifyForm from './StratifyForm.vue';

export default defineComponent({
	components: {
		StratifyForm,
	},
	props: {
		initialFieldIds: {
			type: Array as () => string[],
		},
	},
	setup() {
		const isDialogVisible = ref<boolean>(false);

		const handleClick = () => {
			isDialogVisible.value = true;
		};

		return {
			handleClick,
			isDialogVisible,
		};
	},
});
</script>
